{
  "extends": [
    "stylelint-config-standard",
    "stylelint-config-recommended"
  ],
  "plugins": [
    "stylelint-declaration-block-no-ignored-properties",
    "stylelint-declaration-strict-value",
    "stylelint-order",
    "stylelint-scss"
  ],
  "rules": {
    "custom-property-empty-line-before": "always",
    "comment-empty-line-before": "always",
    "scss/at-else-closing-brace-newline-after": "always-last-in-chain",
    "at-rule-no-unknown": null,
    "scss/at-rule-no-unknown": true,
    "color-no-invalid-hex": true,
    "declaration-block-no-duplicate-properties": true,
    "declaration-block-no-shorthand-property-overrides": true,
    "font-family-no-duplicate-names": true,
    "function-no-unknown": true,
    "function-calc-no-unspaced-operator": true,
    "function-linear-gradient-no-nonstandard-direction": true,
    "string-no-newline": true,
    "unit-no-unknown": true,
    "property-no-unknown": true,
    "keyframe-declaration-no-important": true,
    "declaration-block-single-line-max-declarations": [
      1,
      {}
    ],
    "selector-max-id": 0,
    "selector-max-type": [
      1,
      {
        "ignore": [
          "child",
          "descendant",
          "compounded"
        ]
      }
    ],
    "selector-max-universal": 1,
    "selector-max-attribute": 1,
    "selector-max-class": 3,
    "selector-max-combinators": 2,
    "at-rule-empty-line-before": [
      "always",
      {
        "except": [
          "blockless-after-same-name-blockless",
          "first-nested"
        ],
        "ignore": [
          "after-comment"
        ]
      }
    ],
    "selector-max-compound-selectors": [
      3,
      {
        "ignore": [
          "child",
          "descendant",
          "compounded"
        ]
      }
    ],
    "selector-max-specificity": [
      "0,3,3",
      {}
    ],
    "selector-max-pseudo-class": 2,
    "selector-no-qualifying-type": [
      true,
      {
        "ignore": [
          "attribute",
          "class",
          "id"
        ]
      }
    ],
    "selector-no-vendor-prefix": true,
    "media-feature-name-no-unknown": true,
    "at-rule-no-vendor-prefix": true,
    "property-no-vendor-prefix": true,
    "value-no-vendor-prefix": true,
    "declaration-no-important": true,
    "length-zero-no-unit": true,
    "number-max-precision": [
      3,
      {
        "ignore": [
          "relative"
        ]
      }
    ],
    "time-min-milliseconds": 100,
    "shorthand-property-no-redundant-values": true,
    "selector-attribute-quotes": "always",
    "selector-pseudo-element-colon-notation": "double",
    "comment-no-empty": true,
    "comment-whitespace-inside": "always",
    "no-empty-source": true,
    "declaration-property-value-disallowed-list": {
      "/^border/": [
        "none"
      ]
    },
    "plugin/declaration-block-no-ignored-properties": true,
    "order/order": [
      "custom-properties",
      "dollar-variables",
      "declarations",
      {
        "type": "at-rule",
        "name": "include"
      },
      {
        "type": "at-rule",
        "name": "extend"
      }
    ],
    "order/properties-order": [
      {
        "groupName": "positioning",
        "properties": [
          "position",
          "top",
          "right",
          "bottom",
          "left",
          "z-index"
        ]
      },
      {
        "groupName": "box-model",
        "properties": [
          "display",
          "flex",
          "flex-direction",
          "flex-wrap",
          "flex-flow",
          "justify-content",
          "align-items",
          "align-content",
          "order",
          "flex-grow",
          "flex-shrink",
          "flex-basis",
          "width",
          "min-width",
          "max-width",
          "height",
          "min-height",
          "max-height",
          "padding",
          "padding-top",
          "padding-right",
          "padding-bottom",
          "padding-left",
          "margin",
          "margin-top",
          "margin-right",
          "margin-bottom",
          "margin-left",
          "overflow",
          "overflow-x",
          "overflow-y",
          "box-sizing"
        ]
      },
      {
        "groupName": "typography",
        "properties": [
          "font",
          "font-family",
          "font-size",
          "font-weight",
          "font-style",
          "font-variant",
          "font-size-adjust",
          "font-stretch",
          "font-effect",
          "font-emphasize",
          "font-emphasize-position",
          "font-emphasize-style",
          "font-smooth",
          "line-height",
          "letter-spacing",
          "word-spacing",
          "color",
          "text-align",
          "text-align-last",
          "text-transform",
          "text-decoration",
          "text-emphasis",
          "text-emphasis-color",
          "text-emphasis-style",
          "text-emphasis-position",
          "text-indent",
          "text-justify",
          "text-outline",
          "text-wrap",
          "text-overflow",
          "text-overflow-ellipsis",
          "text-overflow-mode",
          "text-shadow",
          "white-space",
          "word-wrap",
          "word-break",
          "overflow-wrap",
          "tab-size",
          "hyphens",
          "unicode-bidi",
          "columns",
          "column-count",
          "column-fill",
          "column-gap",
          "column-rule",
          "column-rule-color",
          "column-rule-style",
          "column-rule-width",
          "column-span",
          "column-width",
          "page-break-after",
          "page-break-before",
          "page-break-inside",
          "src"
        ]
      },
      {
        "groupName": "visual",
        "properties": [
          "list-style",
          "list-style-position",
          "list-style-type",
          "list-style-image",
          "table-layout",
          "empty-cells",
          "caption-side",
          "background",
          "background-color",
          "background-image",
          "background-repeat",
          "background-position",
          "background-position-x",
          "background-position-y",
          "background-size",
          "background-clip",
          "background-origin",
          "background-attachment",
          "background-blend-mode",
          "border",
          "border-color",
          "border-style",
          "border-width",
          "border-top",
          "border-top-color",
          "border-top-width",
          "border-top-style",
          "border-right",
          "border-right-color",
          "border-right-width",
          "border-right-style",
          "border-bottom",
          "border-bottom-color",
          "border-bottom-width",
          "border-bottom-style",
          "border-left",
          "border-left-color",
          "border-left-width",
          "border-left-style",
          "border-radius",
          "border-top-left-radius",
          "border-top-right-radius",
          "border-bottom-right-radius",
          "border-bottom-left-radius",
          "border-image",
          "border-image-source",
          "border-image-slice",
          "border-image-width",
          "border-image-outset",
          "border-image-repeat",
          "border-collapse",
          "border-spacing",
          "box-shadow",
          "outline",
          "outline-width",
          "outline-color",
          "outline-style",
          "outline-offset",
          "opacity",
          "filter",
          "visibility",
          "size",
          "zoom",
          "transform",
          "transform-origin",
          "transform-style",
          "backface-visibility",
          "perspective",
          "perspective-origin",
          "user-select",
          "pointer-events",
          "cursor",
          "nav-index",
          "nav-up",
          "nav-right",
          "nav-down",
          "nav-left",
          "transition",
          "transition-delay",
          "transition-timing-function",
          "transition-duration",
          "transition-property",
          "animation",
          "animation-name",
          "animation-duration",
          "animation-play-state",
          "animation-timing-function",
          "animation-delay",
          "animation-iteration-count",
          "animation-direction"
        ]
      },
      {
        "groupName": "misc",
        "properties": [
          "appearance",
          "content",
          "clip",
          "clip-path",
          "counter-reset",
          "counter-increment",
          "resize",
          "user-select",
          "nav-index",
          "nav-up",
          "nav-right",
          "nav-down",
          "nav-left",
          "pointer-events",
          "quotes",
          "touch-action",
          "will-change",
          "zoom",
          "fill",
          "stroke"
        ]
      }
    ]
  }
}
